﻿<%@ Page Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
<asp:Content ID="indexTitle" ContentPlaceHolderID="TitleContent" runat="server">Home Page</asp:Content>
<asp:Content ContentPlaceHolderID="HeadContent" runat="server">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <%--CSS Files--%>
    <link href="<%= Url.Content("~/Content/jquery-ui-1.8.11.css") %>" rel="stylesheet" type="text/css" />
    <link href="<%= Url.Content("~/Content/ui.jqgrid.css") %>" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .myAltRowClass { background-color: #DCFFFF; background-image: none; }

        /* fix the size of the pager */
        input.ui-pg-input { width: auto; }
        /* fix the grid width */
        table { border-style:none; border-collapse:separate; }
        table td { border-style:none; }
    </style>

    <%--jQuery Library--%>
    <script src="<%= Url.Content("~/Scripts/jquery-1.6.2.min.js") %>" type="text/javascript"></script>
    
    <%--Must load language tag BEFORE script tag--%>
    <script src="<%= Url.Content("~/Scripts/grid.locale-en.js") %>" type="text/javascript"></script>
    <script src="<%= Url.Content("~/Scripts/jquery.jqGrid.min.js") %>" type="text/javascript"></script>
  
    <%--jqGrid Code - refer http://www.trirand.com/blog/jqgrid/jqgrid.html --%>
    <script type="text/javascript">
        $(document).ready(function() {
            var myGrid = $('#list'),
                decodeErrorMessage = function(jqXHR, textStatus, errorThrown) {
                    var html, errorInfo, i, errorText = textStatus + '\n' + errorThrown;
                    if (jqXHR.responseText.charAt(0) === '[') {
                        try {
                            errorInfo = $.parseJSON(jqXHR.responseText);
                            errorText = "";
                            for (i=0; i<errorInfo.length; i++) {
                               if (errorText.length !== 0) {
                                   errorText += "<hr/>";
                               }
                               errorText += errorInfo[i].Source + ": " + errorInfo[i].Message;
                            }
                        }
                        catch (e) { }
                    } else {
                        html = /<body.*?>([\s\S]*)<\/body>/.exec(jqXHR.responseText);
                        if (html !== null && html.length > 1) {
                            errorText = html[1];
                        }
                    }
                    return errorText;
                };
            myGrid.jqGrid({
                url: '<%= Url.Action("DynamicGridData") %>',
                datatype: 'json',
                mtype: 'POST',
                colNames: ['Id', 'Votes', 'Title'],
                colModel: [
                    { name: 'Id', index: 'Id', key: true, width: 40,
                        searchoptions: { sopt: ['eq', 'ne', 'lt', 'le', 'gt', 'ge'] }
                    },
                    { name: 'Votes', index: 'Votes', width: 40,
                        searchoptions: { sopt: ['eq', 'ne', 'lt', 'le', 'gt', 'ge'] }
                    },
                    { name: 'Title', index: 'Title', width: 400,
                        searchoptions: { sopt: ['cn', 'nc', 'bw', 'bn', 'eq', 'ne', 'ew', 'en', 'lt', 'le', 'gt', 'ge'] }
                    }
                ],
                pager: '#pager',
                rowNum: 10,
                rowList: [5, 10, 20, 50],
                sortname: 'Id',
                sortorder: 'desc',
                rownumbers: true,
                viewrecords: true,
                altRows: true,
                altclass: 'myAltRowClass',
                height: '100%',
                gridview: true,
                jsonReader: { cell: "" },
                caption: 'My first grid',
                loadError: function(jqXHR, textStatus, errorThrown) {
                    // remove error div if exist
                    $('#' + this.id + '_err').remove();
                    // insert div with the error description before the grid
                    myGrid.closest('div.ui-jqgrid').before(
                        '<div id="' + this.id + '_err" style="max-width:'+this.style.width+
                        ';"><div class="ui-state-error ui-corner-all" style="padding:0.7em;float:left;"><span class="ui-icon ui-icon-alert" style="float:left; margin-right: .3em;"></span><span style="clear:left">' +
		                decodeErrorMessage(jqXHR, textStatus, errorThrown) + '</span></div><div style="clear:left"/></div>')
                },
                loadComplete: function() {
                    // remove error div if exist
                    $('#' + this.id + '_err').remove();
                }
            });
            myGrid.jqGrid('navGrid', '#pager', { add: false, edit: false, del: false },
                          {}, {}, {}, { multipleSearch: true, overlay: false, width:460 });
            myGrid.jqGrid('filterToolbar', { stringResult: true, searchOnEnter: true, defaultSearch: 'cn' });
            myGrid.jqGrid('navButtonAdd', '#pager',
                        { caption: "Filter", title: "Toggle Searching Toolbar",
                            buttonicon: 'ui-icon-pin-s',
                            onClickButton: function() { myGrid[0].toggleToolbar(); }
                        });
        }); 
    </script>  

</asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">
    <%-- HTML Required--%>
    <h2>My Grid Data</h2>
    <table id="list"></table>
    <div id="pager"></div>
</asp:Content>
